/*
 * EVALUATE.C - A small routine that makes a call to the EVAL_A Primos function
 *              and expands any global variables and/or CPL functions.
 *
 * Calling syntax:
 * --------------------------------------------------------------------------
 * error = evaluate(language, text, max);
 *
 * long integer ..... language and max.
 * string ........... text.
 *
 * Supported languages:
 * --------------------------------------------------------------------------
 * 0 ..... C (char *)
 * 1 ..... PL/1 (char (1024) var) or PASCAL (string)
 *
 * Date     Programmer     History
 * -------- -------------- --------------------------------------------------
 * 870724   P. Eriksson    Template constructed.
 * 870902   P. Eriksson    Exchanged the language type numbers.
 */

#include <stdio.h>
#include "estruct.h"

#if PR1MOS && EVALST
#include <errd>

#define GVARAREA (char *) (06005 * 128 * 1024)
#define PL1NULL  (char *) (07777 * 128 * 1024)

typedef union
{
   char *c;
   struct
   {
      short length;
      char  text[1025];
   } pl1;
} string;


evaluate(language, max, text)
string text;
{
   short error = 0;
   short com_error = 0;
   string cmdline;
   fortran void eval_a();

   switch (language)
   {
      case 0:  /* C */
         if (strlen(text.c) > 1024 || max > 1024)
            com_error = e$bfts;
         else
         {
            strcpy(cmdline.pl1.text, text.c);
            cmdline.pl1.length = strlen(text.c);
            eval_a(cmdline.pl1, 0, PL1NULL, GVARAREA, (short) max, error, com_error);
            cmdline.pl1.text[cmdline.pl1.length] = '\0';
            strcpy(text.c, cmdline.pl1.text);
         }
         break;
      
      case 1:  /* PL/1 */
         eval_a(text.pl1, 0, PL1NULL, GVARAREA, (short) max, error, com_error);
         break;
         
      default: /* Unknown */
         com_error = e$bkey;
   }

   return (com_error);
}
#endif
