/*
** EFUNC.C                                    Function declarations and names.
**
** (c) 1989 Findata Finansiell Information AB.
**
** Date     Programmer     History
** -------- -------------- -----------------------------------------------------
** 890521   P. Eriksson    Initial coding.
*/

#include <stdio.h>
#include "estruct.h"
#include "edef.h"
#include "efunc.h"

/*   Name to function binding table

      This table gives the names of all the bindable functions
   end their C function address. These are used for the bind-to-key
   function.
*/


NBIND   names[] = {
   {"add",                              addvar},
   {"add-mode",                         setmode},
   {"add-global-mode",                  setgmode},
   {"append-file",                      fileappend},
   {"append-region",                    appendregion},
   {"back-tab",                         backtab},
   {"begin-macro",                      ctlxlp},
   {"beginning-of-file",                gotobob},
   {"beginning-of-line",                gotobol},
   {"bind-to-key",                      bindtokey},
   {"buffer-position",                  showcpos},
   {"case-region-lower",                lowerregion},
   {"case-region-upper",                upperregion},
   {"case-word-capitalize",             capword},
   {"case-word-lower",                  lowerword},
   {"case-word-upper",                  upperword},
   {"change-file-name",                 filename},
   {"clear-and-redraw",                 refresh},
   {"clear-message-line",               clrmes},
   {"copy-region",                      copyregion},
   {"copy-region-append",               copyregadd},
   {"copy-buffer-append",               copybufadd},
#if   WORDPRO
   {"count-words",                      wordcount},
#endif
   {"ctlx-prefix",                      cex},
   {"delete-blank-lines",               deblank},
   {"delete-mode",                      delmode},
   {"delete-global-mode",               delgmode},
   {"delete-next-character",            forwdel},
   {"delete-next-word",                 delfword},
   {"delete-other-windows",             onlywind},
   {"delete-previous-character",        backdel},
   {"delete-previous-word",             delbword},
   {"delete-window",                    delwind},
   {"describe-bindings",                desbind},
   {"describe-key",                     deskey},
#if PRIMOS
   {"display-cl-mode",                  dispclmode},
#endif
   {"display-line",                     sayline},
   {"display-variable",                 displayvar},
   {"else",                             elsecmd},
#if EMAIL && PRIMOS
   {"email-send",                       emailsend},
#endif
   {"endif",                            endcmd},
   {"end-macro",                        ctlxrp},
   {"end-of-file",                      gotoeob},
   {"end-of-line",                      gotoeol},
   {"exchange-point-and-mark",          swapmark},
   {"execute-buffer",                   execbuf},
   {"execute-command-line",             execcmd},
   {"execute-file",                     execfile},
   {"execute-macro",                    ctlxe},
   {"execute-macro-1",                  cbuf1},
   {"execute-macro-2",                  cbuf2},
   {"execute-macro-3",                  cbuf3},
   {"execute-macro-4",                  cbuf4},
   {"execute-macro-5",                  cbuf5},
   {"execute-macro-6",                  cbuf6},
   {"execute-macro-7",                  cbuf7},
   {"execute-macro-8",                  cbuf8},
   {"execute-macro-9",                  cbuf9},
   {"execute-macro-10",                 cbuf10},
   {"execute-macro-11",                 cbuf11},
   {"execute-macro-12",                 cbuf12},
   {"execute-macro-13",                 cbuf13},
   {"execute-macro-14",                 cbuf14},
   {"execute-macro-15",                 cbuf15},
   {"execute-macro-16",                 cbuf16},
   {"execute-macro-17",                 cbuf17},
   {"execute-macro-18",                 cbuf18},
   {"execute-macro-19",                 cbuf19},
   {"execute-macro-20",                 cbuf20},
   {"execute-macro-21",                 cbuf21},
   {"execute-macro-22",                 cbuf22},
   {"execute-macro-23",                 cbuf23},
   {"execute-macro-24",                 cbuf24},
   {"execute-macro-25",                 cbuf25},
   {"execute-macro-26",                 cbuf26},
   {"execute-macro-27",                 cbuf27},
   {"execute-macro-28",                 cbuf28},
   {"execute-macro-29",                 cbuf29},
   {"execute-macro-30",                 cbuf30},
   {"execute-macro-31",                 cbuf31},
   {"execute-macro-32",                 cbuf32},
   {"execute-macro-33",                 cbuf33},
   {"execute-macro-34",                 cbuf34},
   {"execute-macro-35",                 cbuf35},
   {"execute-macro-36",                 cbuf36},
   {"execute-macro-37",                 cbuf37},
   {"execute-macro-38",                 cbuf38},
   {"execute-macro-39",                 cbuf39},
   {"execute-macro-40",                 cbuf40},
   {"execute-named-command",            namedcmd},
   {"exit-emacs",                       quit},
#if   WORDPRO
   {"fill-paragraph",                   fillpara},
#endif
   {"filter-buffer",                    filter},
   {"find-file",                        filefind},
   {"find-next-space",                  find_next_space},
   {"find-next-digit",                  find_next_digit},
   {"find-next-alpha",                  find_next_alpha},
   {"find-prev-space",                  find_prev_space},
   {"find-prev-digit",                  find_prev_digit},
   {"find-prev-alpha",                  find_prev_alpha},

   {"find-next-non-space",              find_next_nonspace},
   {"find-next-non-digit",              find_next_nondigit},
   {"find-next-non-alpha",              find_next_nonalpha},
   {"find-prev-non-space",              find_prev_nonspace},
   {"find-prev-non-digit",              find_prev_nondigit},
   {"find-prev-non-alpha",              find_prev_nonalpha},

#if FUNCFIX
   {"function-prefix",                  funcprefix},
#endif
   {"goto-line",                        gotoline},
   {"grow-window",                      enlargewind},
   {"handle-tab",                       tab},
   {"hunt-forward",                     forwhunt},
   {"hunt-backward",                    backhunt},
   {"help",                             help},
   {"i-shell",                          spawncli},
   {"if",                               ifcmd},
#if   ISRCH
   {"incremental-search",               fisearch},
#endif
   {"indent-region",                    indregion},
   {"unindent-region",                  unindregion},
   {"insert-file",                      insfile},
   {"insert-space",                     insspace},
   {"insert-string",                    istring},
   {"kill-buffer",                      killthisbuf},
   {"kill-buffer-append",               killbufadd},
   {"kill-end-line",                    killtext},
   {"kill-end-buffer",                  killtoend},
   {"kill-start-line",                  killstartline},
   {"kill-start-buffer",                killtostart},
   {"kill-named-buffer",                killbuffer},
#if   WORDPRO
   {"kill-paragraph",                   killpara},
#endif
   {"kill-region",                      killregion},
   {"kill-region-append",               killregadd},
   {"list-buffers",                     listbuffers},
   {"meta-prefix",                      meta},
   {"move-window-down",                 mvdnwind},
   {"move-window-up",                   mvupwind},
   {"name-buffer",                      namebuffer},
   {"newline",                          newline},
   {"newline-and-indent",               indent},
   {"next-buffer",                      nextbuffer},
   {"next-character",                   forwchar},
   {"next-line",                        forwline},
   {"next-page",                        forwpage},
#if   WORDPRO
   {"next-paragraph",                   gotoeop},
#endif
   {"next-window",                      nextwind},
   {"next-word",                        forwword},
   {"open-line",                        openline},
   {"overlay-mode-toggle",              overins},
   {"pipe-command",                     pipe},
   {"previous-character",               backchar},
   {"previous-line",                    backline},
   {"previous-page",                    backpage},
#if   WORDPRO
   {"previous-paragraph",               gotobop},
#endif
   {"previous-window",                  prevwind},
   {"previous-word",                    backword},
   {"query-replace-string",             qreplace},
   {"quick-exit",                       quickexit},
   {"quote-character",                  quote},
#if CTLCFIX
   {"repeat-last",                      repeat_last},
#endif
   {"read-file",                        fileread},
   {"redraw-display",                   reposition},
   {"redraw-display-limit",             reposlimit},
   {"resize-window",                    resize},
   {"restore-window",                   restwnd},
   {"replace-string",                   sreplace},
#if   ISRCH
   {"reverse-incremental-search",       risearch},
#endif
   {"safe-append-file",                 safefileappend},
   {"safe-save-file",                   safefilesave},
   {"safe-write-file",                  safefilewrite},
   {"save-file",                        filesave},
   {"save-window",                      savewnd},
   {"scroll-next-up",                   scrnextup},
   {"scroll-next-down",                 scrnextdw},
   {"search-forward",                   forwsearch},
   {"search-reverse",                   backsearch},
   {"select-buffer",                    usebuffer},
#if PRIMOS
   {"set-cl-mode",                      setclmode},
#endif
#if COUNTUP
   {"set-countup",                      setcountup},
#endif
   {"set-fill-column",                  setfillcol},
   {"set-mark",                         setmark},
   {"set-variable",                     assignvar},
   {"set-width",                        setwidth},
   {"subtract",                         subtractvar},
   {"mark-top",                         marktop},
   {"mark-bottom",                      markbottom},
   {"mark-whole",                       markwhole},
   {"shell-command",                    spawn},
   {"shrink-window",                    shrinkwind},
   {"split-current-window",             splitwind},
   {"store-macro",                      storemac},
#if   BSD
   {"suspend-emacs",                    bktoshell},
#endif
   {"transpose-characters",             twiddle},
   {"unbind-key",                       unbindkey},
   {"unmark-buffer",                    unmark},
   {"update-screen",                    upscreen},
   {"view-file",                        viewfile},
   {"white-delete",                     decblank},
   {"write-file",                       filewrite},
   {"write-region",                     writeregion},
   {"write-message",                    writemsg},
   {"yank",                             yank},
   {"yank-buffer",                      yank},
   {"yank-file-append",                 yankappend},
   {"yank-file-write",                  yankwrite},
   {"",                                 NULL}
};

