/*
** EMAIL.C                              An interface to the EMAIL EMS system.
**
** (c) 1989 Findata Finansiell Information AB.
**
** Date     Programmer     History
** -------- -------------- -----------------------------------------------------
** 890527   P. Eriksson    Initial coding.
*/

#include <stdio.h>

#include "estruct.h"
#include "edef.h"

#if PRIMOS && EMAIL

emailsend(f, n)
{
   extern char *cuserid();
   char username[33];
   char pathname[257];
   long bt;
   int s;
   WINDOW *wp;


   time(&bt);

   /*
   ** Clear the modified flag
   */
   curbp->b_flag &= ~BFCHG;
   wp = wheadp;                    /* Update mode lines.   */
   while (wp != NULL)
   {
      if (wp->w_bufp == curbp)
         wp->w_flag |= WFMODE;

      wp = wp->w_wndp;
   }

   if ((s = mlreply("E-Mail: Send letter to: ", username, 32)) != TRUE)
      return s;

   sprintf(pathname, "EMAIL*>BOXES>%s>OUT>%s/%d",
      cuserid(NULL), username, bt);

   if (writeout(pathname, TRUE) != TRUE)
   {
      mlwrite("[Unable to mail letter (%s)]", pathname);
      return FALSE;
   }

   if (NotifyEmailServer() == -1)
   {
      mlwrite("[Unable to notify EMAIL server]");
      return FALSE;
   }
   else
   {
      mlwrite("[Letter mailed]");
      return TRUE;
   }
}



int OpenSemaphore(Pathname)
char *Pathname;
{
   fortran void SEM$OU();
   int   FileID;
   short SemID, ErrorCode;


   if ((FileID = open(Pathname, 0)) == -1)
      return -1;

   SEM$OU( (short) bio$primosfileunit(FileID),
           1,
           SemID,
           -1,
           ErrorCode );

   close(FileID);

   if (ErrorCode)
      return -1;
   else
      return SemID;
}


int CloseSemaphore(SemID)
int SemID;
{
   fortran void SEM$CL();
   short ErrorCode;

   SEM$CL((short) SemID, ErrorCode);

   return (ErrorCode ? -1 : 0);
}


int NotifySemaphore(SemID)
int SemID;
{
   fortran void SEM$NF();
   short ErrorCode;

   SEM$NF( (short) SemID, ErrorCode );

   return (ErrorCode ? -1 : 0);
}


NotifyEmailServer()
{
   int SemID;

   if ((SemID = OpenSemaphore("EMAIL*>SEMAPHORE")) == -1)
   {
      puts("Couldn't open the semaphore!");
      return -1;
   }

   if (NotifySemaphore(SemID) == -1)
   {
      puts("Couldn't notify the semaphore!");
      return -1;
   }

   if (CloseSemaphore(SemID) == -1)
   {
      puts("Couldn't close the semaphore!");
      return -1;
   }

   return 0;
}

#endif
