/*
 * The functions in this file negotiate with the operating system for
 * characters, and write characters in a barely buffered fashion on the display
 * All operating systems.
 */
#include        <stdio.h>
#include        "estruct.h"
#include        "edef.h"

#if     AMIGA
#define NEW 1006
#define AMG_MAXBUF      1024
static long terminal;
static char scrn_tmp[AMG_MAXBUF+1];
static int  scrn_tmp_p = 0;
#endif

#if PRIMOS
set_aproto(proto)
char *proto;
{
   short code = 0;
   fortran void APROTO();


   sleep(1);
   APROTO((short) -1, (char []) proto, code);
   if (code)
   {
      errno = code;
      perror("\n\nFatal Error in APROTO, Please SAVE");
      sleep(5);
   }
}
#endif


#if     VMS
#include        <stsdef.h>
#include        <ssdef.h>
#include        <descrip.h>
#include        <iodef.h>
#include        <ttdef.h>
#include   <tt2def.h>

#define NIBUF   128                     /* Input buffer size            */
#define NOBUF   1024                    /* MM says bug buffers win!     */
#define EFN     0                       /* Event flag                   */

char    obuf[NOBUF];                    /* Output buffer                */
int     nobuf;                  /* # of bytes in above    */
char    ibuf[NIBUF];                    /* Input buffer          */
int     nibuf;                  /* # of bytes in above  */
int     ibufi;                  /* Read index                   */
int     oldmode[3];                     /* Old TTY mode bits            */
int     newmode[3];                     /* New TTY mode bits            */
short   iochan;                  /* TTY I/O channel             */
#endif

#if     CPM
#include        <bdos.h>
#endif

#if     MSDOS & (LATTICE | MSDOS)
#include <dos.h>
union REGS rg;      /* cpu  for use of DOS calls */
int nxtchar = -1;   /* character held from type ahead    */
#endif

#if RAINBOW
#include "rainbow.h"
#endif

#if   USG                 /* System V */
#include   <signal.h>
#include   <termio.h>
struct   termio   otermio;   /* original terminal characteristics */
struct   termio   ntermio;   /* charactoristics to use inside */
#endif

#if PRIMOS
#include <keys>
short line_number = -1;
int use_amlc = 0;
static short discon_flag = 0;
static short old_tcw;
fortran void C1IN$(), T1OU();
fortran DUPLX$(), SLEEP$();
#endif

#if V7 | BSD
#undef   CTRL
#include   <sgtty.h>        /* for stty/gtty functions */
#include   <signal.h>
vstruct  sgttyb  ostate;          /* saved tty state */
struct  sgttyb  nstate;          /* values for editor mode */
struct tchars   otchars;   /* Saved terminal special character set */
struct tchars   ntchars = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
            /* A lot of nothing */
#if BSD
#include <sys/ioctl.h>      /* to get at the typeahead */
extern   int rtfrmshell();   /* return from suspended shell */
#define   TBUFSIZ   128
char tobuf[TBUFSIZ];      /* terminal output buffer */
#endif
#endif

/*
 * This function is called once to set up the terminal device streams.
 * On VMS, it translates TT until it finds the terminal, then assigns
 * a channel to it and sets it raw. On CPM it is a no-op.
 */
ttopen()
{
#if PRIMOS
   fortran void asnln$(), utype$(), user$(), tp$dis(), tp$con();
   short user_type, user_number, user_count, code, status[2];
   short        amlc_code;
   extern int   aprot_mode;


   if (use_amlc)
   {
      if (line_number == -1)     /* Use this terminal for I/O */
      {
         utype$(user_type);      /* Get type of this process */
         if (user_type != 1)
         {
            puts("You are not a terminal user!");
            exit(1);
         }

         user$(user_number, user_count);  /* Get user number */

         if ((line_number = get_line_no(user_number)) < 0)
         {
            puts("Can't get the line number for this process!");
            printf("Error code = %d\n", line_number);
            exit(1);
         }

         tp$dis(code);           /* Disconnect from line */
         if (code)
         {
            puts("Can't disconnect from the terminal line!");
            exit(1);
         }

         discon_flag = 1;
      }

      code = 0;
      asnln$( 1, line_number, (char []) "TRAN  ", 0, 0, code);
      if (code)
      {
         tp$con(code, 0);
         puts("An error occured while assigning the line!");
         exit(1);
      }
   }

   if (aprot_mode && !use_amlc)
#  if AMLCASNLN
   {
      SLEEP$(100L);            /* Wait for buffers to become empty... */
      amlc_code = set_protocol("TRAN  ");
   }
#  else
   {
      set_aproto("TRAN  ");
   }
#  endif

   old_tcw = DUPLX$((short) 0140000); /* Half Duplex, no LF and no xoff */

#endif   /* end of PRIMOS */



#if     VMS
        struct  dsc$descriptor  idsc;
        struct  dsc$descriptor  odsc;
        char    oname[40];
        int     iosb[2];
        int     status;

        odsc.dsc$a_pointer = "TT";
        odsc.dsc$w_length  = strlen(odsc.dsc$a_pointer);
        odsc.dsc$b_dtype        = DSC$K_DTYPE_T;
        odsc.dsc$b_class        = DSC$K_CLASS_S;
        idsc.dsc$b_dtype        = DSC$K_DTYPE_T;
        idsc.dsc$b_class        = DSC$K_CLASS_S;
        do {
                idsc.dsc$a_pointer = odsc.dsc$a_pointer;
                idsc.dsc$w_length  = odsc.dsc$w_length;
                odsc.dsc$a_pointer = &oname[0];
                odsc.dsc$w_length  = sizeof(oname);
                status = LIB$SYS_TRNLOG(&idsc, &odsc.dsc$w_length, &odsc);
                if (status!=SS$_NORMAL && status!=SS$_NOTRAN)
                        exit(status);
                if (oname[0] == 0x1B) {
                        odsc.dsc$a_pointer += 4;
                        odsc.dsc$w_length  -= 4;
                }
        } while (status == SS$_NORMAL);
        status = SYS$ASSIGN(&odsc, &iochan, 0, 0);
        if (status != SS$_NORMAL)
                exit(status);
        status = SYS$QIOW(EFN, iochan, IO$_SENSEMODE, iosb, 0, 0,
                          oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
        newmode[0] = oldmode[0];
        newmode[1] = oldmode[1] | TT$M_NOECHO;
        newmode[1] &= ~(TT$M_TTSYNC|TT$M_HOSTSYNC);
        newmode[2] = oldmode[2] | TT2$M_PASTHRU;
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                          newmode, sizeof(newmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
v        term.t_nrow = (newmode[1]>>24) - 1;
        term.t_ncol = newmode[0]>>16;

#endif
     /* on all screens we are not sure of the initial position
      of the cursor               */
   ttrow = 999;
   ttcol = 999;

#if     AMIGA
        terminal = Open("RAW:1/1/639/199/MicroEMACS 3.7/Amiga", NEW);
#endif
#if     CPM
#endif

#if     MSDOS & (HP150 == 0) & LATTICE
   /* kill the ctrl-break interupt */
   rg.h.ah = 0x33;      /* control-break check dos call */
   rg.h.al = 1;      /* set the current state */
   rg.h.dl = 0;      /* set it OFF */
   intdos(&rg, &rg);   /* go for it! */
#endif

#if MSDOS & ZORLAND
   dos_set_ctrl_break(0);
#endif

#if   USG
   ioctl(0, TCGETA, &otermio);   /* save old settings */
   ntermio.c_iflag = 0;      /* setup new settings */
   ntermio.c_oflag = 0;
   ntermio.c_cflag = otermio.c_cflag;
   ntermio.c_lflag = 0;
   ntermio.c_line = otermio.c_line;
   ntermio.c_cc[VMIN] = 1;
   ntermio.c_cc[VTIME] = 0;
   ioctl(0, TCSETA, &ntermio);   /* and activate them */
#endif

#if     V7 | BSD
        gtty(0, &ostate);                       /* save old state */
        gtty(0, &nstate);                       /* get base of new state */
        nstate.sg_flags |= RAW;
        nstate.sg_flags &= ~(ECHO|CRMOD);       /* no echo for now... */
        stty(0, &nstate);                       /* set mode */
   ioctl(0, TIOCGETC, &otchars);      /* Save old characters */
   ioctl(0, TIOCSETC, &ntchars);      /* Place new character into K */
#if   BSD
   /* provide a smaller terminal output buffer so that
      the type ahead detection works better (more often) */
   setbuffer(stdout, &tobuf[0], TBUFSIZ);
   signal(SIGTSTP,SIG_DFL);   /* set signals so that we can */
   signal(SIGCONT,rtfrmshell);   /* suspend & restart emacs */
#endif
#endif
}

/*
 * This function gets called just before we go back home to the command
 * interpreter. On VMS it puts the terminal back in a reasonable state.
 * Another no-operation on CPM.
 */
ttclose()
{
#if PRIMOS
   fortran void aproto();
   short        amlc_code;
   extern int   aprot_mode;
   fortran void tp$dis(), tp$con();

   if (use_amlc)
   {
      fortran void asnln$(), tp$con();
      short code;

      if (line_number < 0)    /* Already have TTCLOSE:d it.. */
         return;

      code = 0;
      /* Restore TTY protocol */
      asnln$(1, line_number, (char []) "TTY   ", 0, 0, code);
      if (code)
      {
         tp$con(code, 0);
         puts("An error occured while restoring normal TTY protocol!");
         exit(1);
      }

      if (discon_flag)
      {
         tp$con(code, 0);        /* Restore normal TTY */
         line_number = -1;
         discon_flag = 0;
      }
   }

   DUPLX$(old_tcw);

   if (aprot_mode && !use_amlc)
#  if AMLCASNLN
        {
            SLEEP$(100L);      /* Wait for buffers to become empty... */
            amlc_code = set_protocol("TTY   ");
        }
#  else
              aproto((short) -1, "TTY   ", amlc_code);
#  endif
#endif

#if     AMIGA
        amg_flush();
        Close(terminal);
#endif
#if     VMS
        int     status;
        int     iosb[1];

        ttflush();
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                 oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
        status = SYS$DASSGN(iochan);
        if (status != SS$_NORMAL)
                exit(status);
#endif
#if     CPM
#endif
#if     MSDOS & (HP150 == 0) & LATTICE
   /* restore the ctrl-break interupt */
   rg.h.ah = 0x33;      /* control-break check dos call */
   rg.h.al = 1;      /* set the current state */
   rg.h.dl = 1;      /* set it ON */
   intdos(&rg, &rg);   /* go for it! */
#endif

#if MSDOS & ZORLAND
   dos_set_ctrl_break(1);
#endif

#if   USG
   ioctl(0, TCSETA, &otermio);   /* restore terminal settings */
#endif

#if     V7 | BSD
        stty(0, &ostate);
   ioctl(0, TIOCSETC, &otchars);   /* Place old character into K */
#endif
}

/*
 * Write a character to the display. On VMS, terminal output is buffered, and
 * we just put the characters in the big array, after checking for overflow.
 * On CPM terminal I/O unbuffered, so we just write the byte out. Ditto on
 * MS-DOS (use the very very raw console output routine).
 */
ttputc(c)
#if     AMIGA
        char c;
#endif
{
#if     AMIGA
        scrn_tmp[scrn_tmp_p++] = c;
        if(scrn_tmp_p>=AMG_MAXBUF)
                amg_flush();
#endif
#if     VMS
        if (nobuf >= NOBUF)
                ttflush();
        obuf[nobuf++] = c;
#endif

#if     CPM
        bios(BCONOUT, c, 0);
#endif

#if     MSDOS & MWC86
        dosb(CONDIO, c, 0);
#endif

#if   MSDOS && (LATTICE || MSC || AZTEC || ZORLAND)
#   if ZORLAND
#      if DISPACK
          disp_putc(c);
#      else
          bdos(6, c);
#      endif
#  else
      bdos(6, c, 0);
#   endif
#endif

#if RAINBOW
        Put_Char(c);                    /* fast video */
#endif


#if     V7 | USG | BSD
        fputc(c, stdout);
#endif

#if PRIMOS
   if (use_amlc)
   {
        fortran void t$amlc(), T1OU();
        short status[2];
        short error;
        char cbuf[2];

        if (line_number < 0)
            return;

        cbuf[0] = c;
        t$amlc( line_number, (char *) cbuf, 1, 3, status);
    }
    else
        T1OU((short) c);
#endif
}

#if   AMIGA
amg_flush()
{
        if(scrn_tmp_p)
                Write(terminal,scrn_tmp,scrn_tmp_p);
        scrn_tmp_p = 0;
}
#endif

/*
 * Flush terminal buffer. Does real work where the terminal output is buffered
 * up. A no-operation on systems where byte at a time terminal I/O is done.
 */
ttflush()
{
#if     PRIMOS
   fortran void t$amlc();
   short status[2], code;
   short output_size;
   char cbuf[2];

   if (use_amlc)
   {
      if (line_number < 0)
         return;

      if ((output_size = get_output_size(line_number)) < 0)
         return;

      do
      {
         t$amlc(line_number, (char *) cbuf, 0, 7, status, 1, code);
      } while (status[0] < output_size-1);
   }
#endif
#if     AMIGA
        amg_flush();
#endif
#if     VMS
        int     status;
        int     iosb[2];

        status = SS$_NORMAL;
        if (nobuf != 0) {
                status = SYS$QIOW(EFN, iochan, IO$_WRITELBLK|IO$M_NOFORMAT,
                         iosb, 0, 0, obuf, nobuf, 0, 0, 0, 0);
                if (status == SS$_NORMAL)
                        status = iosb[0] & 0xFFFF;
                nobuf = 0;
        }
        return (status);
#endif

#if     CPM
#endif

#if     MSDOS
#if         ZORLAND && DISPACK
         disp_flush();
#endif
#endif

#if     V7 | USG | BSD
        fflush(stdout);
#endif
}

/*
 * Read a character from the terminal, performing no editing and doing no echo
 * at all. More complex in VMS that almost anyplace else, which figures. Very
 * simple on CPM, because the system can do exactly what you want.
 */
ttgetc()
{
#if     AMIGA
        char ch;
        amg_flush();
        Read(terminal, &ch, 1);
        return(255 & (int)ch);
#endif
#if     VMS
        int     status;
        int     iosb[2];
        int     term[2];

        while (ibufi >= nibuf) {
                ibufi = 0;
                term[0] = 0;
                term[1] = 0;
                status = SYS$QIOW(EFN, iochan, IO$_READLBLK|IO$M_TIMED,
                         iosb, 0, 0, ibuf, NIBUF, 0, term, 0, 0);
                if (status != SS$_NORMAL)
                        exit(status);
                status = iosb[0] & 0xFFFF;
                if (status!=SS$_NORMAL && status!=SS$_TIMEOUT)
                        exit(status);
                nibuf = (iosb[0]>>16) + (iosb[1]>>16);
                if (nibuf == 0) {
                        status = SYS$QIOW(EFN, iochan, IO$_READLBLK,
                                 iosb, 0, 0, ibuf, 1, 0, term, 0, 0);
                        if (status != SS$_NORMAL
                        || (status = (iosb[0]&0xFFFF)) != SS$_NORMAL)
                                exit(status);
                        nibuf = (iosb[0]>>16) + (iosb[1]>>16);
                }
        }
        return (ibuf[ibufi++] & 0xFF);    /* Allow multinational  */
#endif

#if     CPM
        return (biosb(BCONIN, 0, 0));
#endif

#if RAINBOW
        int Ch;

        while ((Ch = Read_Keyboard()) < 0);

        if ((Ch & Function_Key) == 0)
                if (!((Ch & 0xFF) == 015 || (Ch & 0xFF) == 0177))
                        Ch &= 0xFF;

        return Ch;
#endif

#if     MSDOS & MWC86
        return (dosb(CONRAW, 0, 0));
#endif

#if   MSDOS & (LATTICE | MSC | ZORLAND)
   int c;      /* character read */

   /* if a char already is ready, return it */
   if (nxtchar >= 0) {
      c = nxtchar;
      nxtchar = -1;
      return(c);
   }

   /* call the dos to get a char */
   rg.h.ah = 7;      /* dos Direct Console Input call */
   intdos(&rg, &rg);
   c = rg.h.al;      /* grab the char */
   return(c & 255);
#endif

#if   MSDOS & AZTEC
   int c;      /* character read */

   /* if a char already is ready, return it */
   if (nxtchar >= 0) {
      c = nxtchar;
      nxtchar = -1;
      return(c);
   }

   /* call the dos to get a char */
   rg.h.ah = 7;      /* dos Direct Console I/O call */
   sysint(33, &rg, &rg);
   c = rg.h.al;      /* grab the char */
   return(c & 255);
#endif

#if     V7 | USG | BSD
        return(127 & fgetc(stdin));
#endif
#if PRIMOS
   if (use_amlc)
   {
        fortran void t$amlc();
        short status[2];
        short error;
        char cbuf[2];

        if (line_number < 0)
           return NULL;

        t$amlc( line_number, (char *) cbuf, 1, 1, status);
        return (ZZSETP(cbuf[0]));
    }
    else
    {
        short c;
        C1IN$(c, 0, 0);
        return (ZZSETP(c&255));
    }
#endif
}

#if   TYPEAH
/* typahead:   Check to see if any characters are already in the
      keyboard buffer
*/

typahead()

{
#if   MSDOS & (LATTICE | AZTEC | MSC | ZORLAND)
   int c;      /* character read */
   int flags;   /* cpu flags from dos call */

#if   MSC
   if (kbhit() != 0)
      return(TRUE);
   else
      return(FALSE);
#endif

   if (nxtchar >= 0)
      return(TRUE);

   rg.h.ah = 6;   /* Direct Console I/O call */
   rg.h.dl = 255;   /*         does console input */
#if   LATTICE | ZORLAND
   flags = intdos(&rg, &rg);
#else
   flags = sysint(33, &rg, &rg);
#endif
   c = rg.h.al;   /* grab the character */

   /* no character pending */
   if ((flags & 64) != 0)
      return(FALSE);

   /* save the character and return true */
   nxtchar = c;
   return(TRUE);
#endif

#if   BSD
   int x;   /* holds # of pending chars */

   return((ioctl(0,FIONREAD,&x) < 0) ? 0 : x);
#endif
#if PRIMOS
   if (use_amlc)
   {
        fortran void t$amlc();
        short status[2];
        short error;
        char cbuf[2];

        if (line_number < 0)
           return NULL;

        t$amlc( line_number, (char *) cbuf, 0, 4, status);
        return (status[0]);
    }
    else
    {
         fortran short tty$in();

         return(tty$in());
    }
#endif
   return(FALSE);
}
#endif


/*
 * Set screen width. If called with an argument, use that, else prompt for
 * it. An empty answer doesn't change anything.
 */
setwidth(f, n)
{
   char prompt[81];
   char reply[81];
   int width;
   extern TERM term;

   if (!f)
   {
      width = term.t_ncol;
      sprintf(prompt,"Screen width [%d]:",width);
      if (mlreply(prompt,reply,80) == ABORT)
         return(ABORT);
      trimsides(reply);
      if (reply[0])
         width = atoi(reply);
   }
   else
      width = n;
   if (width<1)
   {
      mlwrite("[Window width too small]");
      return(FALSE);
   }
   if (width>=NLINE)
   {
      mlwrite("[Window width too large]");
      return(FALSE);
   }
   term.t_ncol = width;
   updgar();                              /* Force an update of the screen */
   mlwrite("[Window width = %d]",width);
}


tputstr(str)
char *str;
{
   while (*str)
      (*term.t_putchar)(*str++);
}

