/*
** QNX TCAP driver.
*/

#define   termdef   1         /* don't define "term" external */

#include        <stdio.h>
#include        "estruct.h"
#include   "edef.h"

#if QNXTC

#include <tcap.h>


extern unsigned qnx_colour;

#define NROW    24                      /* Screen size.                    */
#define NCOL    80                      /* Edit if you want to.            */
#define MARGIN  8                       /* size of minimim margin and      */
#define SCRSIZ  64                      /* scroll size for extended lines  */
#define NPAUSE  30                      /* # times thru update to pause    */
#define ESC     0x1B                    /* ESC character.                  */
#define BEL     0x07                    /* ascii bell character            */

extern  int     qnxopen();               /* Forward references.          */
extern  int     qnxgetc();
extern  int     ttputc();
extern  int     ttflush();
extern  int     ttclose();
extern  int     qnxmove();
extern  int     qnxeeol();
extern  int     qnxeeop();
extern  int     qnxbeep();
extern  int     qnxopen();
extern   int    qnxrev();
#if   COLOR
extern   int    qnxfcol();
extern   int    qnxbcol();
#endif

/*
 * Dispatch table. All the
 * hard fields just point into the
 * terminal I/O code.
 */
TERM    term    = {
         NROW-1,
         NCOL,
         MARGIN,
         SCRSIZ,
         NPAUSE,
         &qnxopen,
         &ttclose,
         &qnxgetc,
         &ttputc,
         &ttflush,
         &qnxmove,
         &qnxeeol,
         &qnxeeop,
         &qnxbeep,
         &qnxrev
#if   COLOR
   ,     &qnxfcol,
         &qnxbcol
#endif
};


qnxgetc()
{
   return term_key();
}


qnxmove(row, col)
{
   term_cur(row,col);
}

qnxeeol()
{
   term_clear(1);
}

qnxeeop()
{
   term_clear(2);
}

qnxrev(status)   /* set the reverse video state */
int status;   /* TRUE = reverse video, FALSE = normal video */
{
   if (status)
      term_esc(tcap_entry.disp_inverse_beg);
   else
      term_esc(tcap_entry.disp_inverse_end);
}

#if   COLOR
qnxfcol(col)
int col;
{
   term_colour( qnx_colour = (qnx_colour & 0x8F | ((col & 7) << 4)) );
}

qnxbcol(col)
int col;
{
   term_colour( qnx_colour = (qnx_colour & 0xF8 | (col & 7)) );
}
#endif

qnxbeep()
{
   ttputc(BEL);
   ttflush();
}

qnxopen()
{
    ttopen();

#if COLOR
    qnx_colour |= 0x8000;
#endif

    if (term_load(stdout) == 0)
    {
      fprintf(stderr, "Unable to load terminal entry\n");
      exit(1);
    }
}

#endif
