/* Test of the setjmp/longjmp routines for usage with
** the 32IX mode compiler.
**
** Anders Furuhed May 1988
*/

#include <stdio.h>
#include <setjmp.h>

jmp_buf enviroment;     /* Holds the enviroment information */

int     jumping = 0;

fortran void handler ();
fortran void mkon$p ();

main ()
{
   puts ("SETJMP/LONGJMP Test Anders Furuhed May 1988");

   mkon$p ("ACCESS_VIOLATION$", 17, handler);

   setjmp (enviroment);
   if (jumping)
   {
      puts ("An error occured...");
      exit (0);
   }

   another_function ();
}

another_function ()
{
   char reply[80];

   while (1)
   {
      printf ("Enter a Primos command: ");
      gets (reply);
      if (!strcmp (reply, "quit"))
         return;

      system (reply);
   }
}

fortran void handler (cfh)
int *cfh;
{
   puts ("Inside handler");
   jumping = 1;
   longjmp (enviroment, 1);
}


/* SYSTEM - A routine to execute a primos command from within another program */
/*          It will return an integer error code showing how well the command */
/*          was executed and if the command was correctly invoked.  The eight */
/*          least significant bits shows how well the command was executed.   */
/*          The next eight bits (8-15) shows the (if any) command invocation  */
/*          error.                                                            */
/* Authors: Anders Furuhed & Peter Eriksson, V{sterh|jdskolan 1987            */


system(command)
char *command;
{
    fortran cp$();
    struct
      {
      short length;
      char  text[1025];
      } cp$cmd;
    short status,command_status;

    strcpy( cp$cmd.text, command);
    cp$cmd.length = strlen(command);
    cp$(cp$cmd, status, command_status);
    return((int) status<<8 | command_status);
}

