/* Due to the illness of Primes CC_LIBRARY Rev 21.0.2,
** the FILEIO routines have been rewritten to use Primos subroutines directly.
*/

#include <stdio.h>
#include <ctype.h>
#include "estruct.h"
/* #include "edef.h" */

#define TABCHR 0211

#if PR1MOS

#include <keys>


/* Type declarations */
typedef struct
{
   short len;
   char  txt[133];
} charvar;

typedef struct
{
   short len;
   char  txt[32];
} char32var;

fortran void srch$$ ();
fortran void at$ ();
fortran void at$hom ();
fortran int  srsfx$ ();

char         *strrchr ();

/* Global declarations */
int        funit;              /* Primos file unit */
extern int dam_mode;


/* Open file fn for reading */
ffropen (fn)
char *fn;
{
   charvar path;
   char       *ptr;
   short      len;
   short      type;
   short      code;
   short      keys;

   /* Determine if file is in current directory */
   if ((ptr = strrchr (fn, '>')))
   {
      /* Another directory, do a temporary attach there to */
      *ptr = 0;
      path.len = strlen (fn);
      strcpy (path.txt,fn);

      at$ (k$setc,path,code);

      if (code)
      {
         at$hom (code);
         return FIOFNF;
      }

      fn = ptr + 1;
   }

   code = type = funit = 0;
   keys = k$read+k$getu;
   len = strlen (fn);
   srch$$ (keys,(char []) fn,len,funit,type,code);

   /* If necessary attach home from temporary attach point */
   if (ptr)
   {
      at$hom (code);
      if (code)
         return FIOFNF;
   }

   if (code)
      return FIOFNF;

   return FIOSUC;
}


/* Open file for writing */
ffwopen (fn)
char *fn;
{
   char  *ptr;
   short keys;
   short code;
   short type;
   short len;
   charvar path;

   keys = k$writ + k$getu;

   if (dam_mode)
      keys += k$ndam;
   else
      keys += k$nsam;

   /* Determine if file is in current directory */
   if (ptr = strrchr (fn, '>'))
   {
      /* Another directory, do a temporary attach there to */
      *ptr = 0;
      path.len = strlen (fn);
      strcpy (path.txt,fn);

      at$ (k$setc,path,code);

      if (code)
      {
         at$hom (code);
         return FIOFNF;
      }

      fn = ptr + 1;
   }

   len = strlen (fn);
   code = type = funit = 0;

   srch$$ (keys,(char []) fn,len,funit,type,code);

   /* Attach home */
   if (ptr)
   {
      at$hom (code);
      if (code)
         return FIOFNF;
   }
   if (code)
      return FIOFNF;

   return FIOSUC;
}

ffaopen (fn)
char *fn;
{
/*   mlwrite ("You may not do that now!"); */
   return FIOFNF;
}

/* Close file */
ffclose ()
{
   short keys;
   short type;
   short code;
   short len;
   char  *fn;

   keys = k$clos;
   fn   = 0;
   len  = 0;
   type = 0;
   code = 0;

   srch$$ (keys,fn,len,funit,type,code);

   if (code)
   {
/*      mlwrite ("Error closing file"); */
      return FIOERR;
   }

   return FIOSUC;
}

#if FIXSUFF
fix_file_suffix (fname)
char *fname;
{
   static char32var suffix[] =
   {
      2, ".C",
      3, ".CC",
      2, ".H",
      4, ".CPL",
      5, ".COMI",
      5, ".COMO",
      4, ".FTN",
      4, ".F77",
      2, ".P",
      4, ".PAS",
      7, ".PASCAL",
      4, ".CBL",
      6, ".COBOL",
      6, ".BASIC",
      4, ".BAS",
      4, ".PMA",
      4, ".CMA",
      4, ".ASM",
      4, ".PL1",
      5, ".PL1G",
      5, ".PL/1",
      4, ".PLP",
      4, ".SPL",
      6, ".MACRO",
      4, ".RPG",
      4, ".DOC",
      4, ".TXT",
      4, ".PRO",
      6, ".PROLOG",
      4, ".LSP",
      5, ".LISP",
      4, ".INS"
   };

   short    keys;
   charvar  object;
   charvar  basename;
   short    unit;
   short    type;
   short    n_suffixes;
   short    suffix_used;
   short    code;
   int      chrpos;

   object.len = strlen (fname);
   strcpy (object.txt,fname);

   keys          = k$read + k$getu;
   unit          = 0;
   type          = 0;
   n_suffixes    = 32;
   basename.len  = 0;
   suffix_used   = 0;
   code          = 0;

   chrpos = srsfx$ (keys,object,unit,type,n_suffixes,(char32var []) suffix,basename,
                    suffix_used,code);

   if (suffix_used)
      printf ("Suffix: %s\n", suffix[suffix_used].txt);
   else
      puts ("No suffix found");

   basename.txt [basename.len] = 0;
   printf ("Basename: %s\n", basename.txt);

   if (code)
   {
      errno = code;
      perror ("SRSFX$");
   }

   printf ("Unit: %d\n", unit);
}
#endif
#endif
