/*
** DS$ASY.H - An include file for the DS$ASY() routine.
**
** Date     Programmer     History
** -------- -------------- ---------------------------------------------------
** 880325   P. Eriksson    Template constructed.
*/

#nolist

/*
** fortran void DS$ASY(input_key, line_no, output_structure, code)
** short input_key;
** short line_no;
** struct async_list *output_structure;
** short code;
*/

#define DS$ASY_VERSION 1
#define AMLC_LINES     256

fortran void ds$asy();

typedef struct 
{
   unsigned : 1;
} bit_1;

struct async_list
{
   short version;                /* Structure version number               */
   short max_fit;                /* No. of entries structure can handle    */
   short info_count;             /* No. of entries returned                */
   short no_configured;          /* No. of lines configured                */
   short no_loginable;           /* No. of lines available for login       */
   short no_assignable;          /* No. of assignable lines                */
   short no_assigned;            /* No. of assigned lines                  */
   struct
   {
      short line_no;             /* Line number                            */
      short user_no;             /* User number associated with the line   */
      short lconf_flags;         /* LCONF word                             */
      short lword_flags;         /* LWORD word                             */
      short in_size;             /* Input buffer size                      */
      short out_size;            /* Output buffer size                     */
      short amlq_size;           /* AMLQ buffer size                       */
      char protocol[6];          /* Terminal protocol name                 */
      bit_1 asd_configured;      /* auto-speed-detect enabled flag         */
   } info[AMLC_LINES];
};

#list
