/*
** GET_LINE_NO.C - Get the associated line number for the selected user.
**
** Date     Programmer     History
** -------- -------------- ------------------------------------------------
** 880325   P. Eriksson    Template constructed.
*/


#include <keys>
#include <errd>
#include "ds$asy.h"

main(argc,argv)
char *argv[];
{
   fortran void asnln$(), tp$dis(), tp$con(), t$amlc();
   short  code, status[2], lno, o_size;
   char cbuf[2];
   
   lno = atoi(argv[1]);
   printf("Line number = %d\n", lno);

   tp$dis(code);
   asnln$( 1, lno, (char []) "TRAN  ", 0, 0, code);

   o_size = get_output_size(lno);
   t$amlc( lno, (char *) cbuf, 0, 7, status);
   
   asnln$( 1, lno, (char []) "TTY   ", 0, 0, code);
   tp$con(code, 0);

   printf("Output buffer size = %d\n", o_size);
   printf("Output space free  = %d\n", status[0]);
}


get_output_size(line_no)
int line_no;
{
   struct async_list linfo;
   short code;
   
   linfo.version = DS$ASY_VERSION;
   linfo.max_fit = AMLC_LINES;
   code = 0;
   ds$asy(k$line, (short) line_no, &linfo, code);
   if (code)
      return -1;

   if (linfo.info[0].line_no == line_no)
      return linfo.info[0].out_size;
   
   return -2;
}
      

get_line_no(user_no)
int user_no;
{
   int count;
   
   struct async_list linfo;
   short  code;

   linfo.version = DS$ASY_VERSION;
   linfo.max_fit = AMLC_LINES;   
   code = 0;
   ds$asy(k$linu, 0, &linfo, code);
   if (code)
      return -1;

   for (count = 0; count < linfo.info_count; ++count)
      if (linfo.info[count].user_no == -user_no)
         return linfo.info[count].line_no;

   return -2;
}


